MeanPhase PROC
	LOCAL	content[108]:BYTE
	LOCAL	nt0:REAL10

	lea	edx,content

;################################################################################
;#		Time in Julian centuries from 1900 January 0.5			#
;#		t=(sdate-2415020.0)/36525,t2=t*t,t3=t2*t			#
;################################################################################

	fsave	content

	fld	REAL10 PTR[edx+28]					;st=k
	fld	REAL10 PTR[edx+38]					;st=sdate,st(1)=k

	fsub	TwentyFourFifteenZeroTwenty				;st=sdate-2415020.0,st(1)=k
	fdiv	ThirtySixFiveTwentyFive					;st=t=(sdate-2415020.0)/36525,st(1)=k
	fld	st							;st=t,st(1)=t,st(2)=k
	fmul	st,st(1)						;st=t2=t*t,st(1)=t,st(2)=k
	fld	st							;st=t2,st(1)=t2,st(2)=t,st(3)=k
	fmul	st,st(2)						;st=t3=t2*t,st(1)=t2,st(2)=t,st(3)=k
;================================================================================

;################################################################################
;#		nt1=2415020.75933+synmonth*k+0.0001178*t2-0.000000155*t3	#
;#		+0.00033*dsin(166.56+132.87*t-0.009173*t2)			#
;################################################################################
	fmul	OneFiftyFivetenmillionths				;st=0.000000155*t3,st(1)=t2,st(2)=t,st(3)=k
	fxch	st(2)							;st=t,st(1)=t2,st(2)=0.000000155*t3,st(3)=k
	fmul	OneThirtyTwo_EightySevenhundredths			;st=132.87*t,st(1)=t2,st(2)=0.000000155*t3,st(3)=k
	fadd	OneSixtySix_FiftySixhundredths				;st=166.56+132.87*t,st(1)=t2,st(2)=0.000000155*t3,st(3)=k
	fld	Ninethousandths						;st=0.009173,st(1)=166.56+132.87*t,st(2)=t2,st(3)=0.000000155*t3,st(4)=k
	fmul	st,st(2)						;st=0.009173*t2,st(1)=166.56+132.87*t,st(2)=t2,st(3)=0.000000155*t3,st(4)=k
	fsub								;st=166.56+132.87*t-0.009173*t2,st(1)=t2,st(2)=0.000000155*t3,st(3)=k

	INVOKE	FPUDegtoRad						;st=degtorad(166.56+132.87*t-0.009173*t2),st(1)=t2,st(2)=0.000000155*t3,st(3)=k

	fsin								;st=sin(degtorad(166.56+132.87*t-0.009173*t2)),st(1)=t2,st(2)=0.000000155*t3,st(3)=k
	fmul	ThirtyThreetenthousanths				;st=0.00033*sin(degtorad(166.56+132.87*t-0.009173*t2)),st(1)=t2,st(2)=0.000000155*t3,st(3)=k
	fsubrp	st(2),st						;st=t2,st(1)=-0.000000155*t3+0.00033*sin(degtorad(166.56+132.87*t-0.009173*t2)),st(2)=k
	fmul	Elevententhousanths					;st=0.0001178*t2,st(1)=-0.000000155*t3+0.00033*sin(degtorad(166.56+132.87*t-0.009173*t2)),st(2)=k
	fadd								;st=0.0001178*t2-0.000000155*t3+0.00033*sin(degtorad(166.56+132.87*t-0.009173*t2)),st(1)=k
	fld	synmonth						;st=synmonth,st(1)=0.0001178*t2-0.000000155*t3+0.00033*sin(degtorad(166.56+132.87*t-0.009173*t2)),st(2)=k
	fmul	st,st(2)						;st=synmonth*k,st(1)=0.0001178*t2-0.000000155*t3+0.00033*sin(degtorad(166.56+132.87*t-0.009173*t2)),st(2)=k
	fadd								;st=synmonth*k+0.0001178*t2-0.000000155*t3+0.00033*sin(degtorad(166.56+132.87*t-0.009173*t2)),st(1)=k
	fadd	TwentyFourFifteenZeroTwenty_Seventenths			;st=nt1=2415020.75933+synmonth*k+0.0001178*t2-0.000000155*t3+0.00033*sin(degtorad(166.56+132.87*t-0.009173*t2)),st(1)=k
;================================================================================

	fstp	nt0
	frstor	content
	fld	nt0

	ret

MeanPhase ENDP