MoonPhaseHunt PROC
	LOCAL	content[108]:BYTE
	LOCAL	mcontent[108]:BYTE

	lea	edx,adate
	lea	eax,JulianTime

	fsave	content

;################################################################################
;#				sdate=JulianDay					#
;################################################################################
	fld	JulianDay				;st=JulianDay
;================================================================================

;################################################################################
;#				adate=sdate-45.0				#
;################################################################################
	fld	FortyFive				;st=45.0,st(1)=sdate
	fsubr	st,st(1)				;st=adate=sdate-45.0,st(1)=sdate
;================================================================================

	fld	st
	fstp	adate					;st=adate,st(1)=sdate

	INVOKE	JulianDaytoCalendar

;################################################################################
;#		k1=floor((y+((m-1)*(1.0/12.0))-1900.0)*12.3685)			#
;################################################################################
	lea	edx,JulianTime
	fld	Twelve					;st=12.0,st(1)=adate,st(2)=sdate
	fld1						;st=1.0,st(1)=12.0,st(2)=adate,st(3)=sdate
	fdivr	st(1),st				;st=1.0,st(1)=1.0/12.0,st(2)=adate,st(3)=sdate
	fisubr	(SYSTEMTIME PTR[edx]).wMonth		;st=m-1.0,st(1)=1.0/12.0,st(2)=adate,st(3)=sdate
	fmul						;st=(m-1.0)*(1.0/12.0),st(1)=adate,st(2)=sdate
	fiadd	(SYSTEMTIME PTR[edx]).wYear		;st=y+((m-1.0)*(1.0/12.0)),st(1)=adate,st(2)=sdate
	fsub	Nineteenhundred				;st=y+((m-1.0)*(1.0/12.0))-1900.0,st(1)=adate,st(2)=sdate
	fmul	Twelve_ThirtySixhundredths		;st=(y+((m-1.0)*(1.0/12.0))-1900.0)*12.3685,st(1)=adate,st(2)=sdate

	INVOKE	FPUFloor				;st=k1=floor((y+((m-1.0)*(1.0/12.0))-1900.0)*12.3685),st(1)=adate,st(2)=sdate

;================================================================================

;################################################################################
;#			adate=nt1=meanphase(adate,k1)				#
;################################################################################

	INVOKE	MeanPhase				;st=adate=nt1=meanphase(adate,k1),st(1)=k1,st(2)=adate,st(3)=sdate

	fst	st(2)					;st=adate,st(1)=k1,st(2)=nt1,st(3)=sdate
;================================================================================

;################################################################################
;#			adate=adate+synmonth,k2=k1+1				#
;################################################################################

MoonPhaseHunt00000:

	fadd	synmonth				;st=adate=adate+synmonth,st(1)=k1,st(2)=nt1,st(3)=sdate
	fld1						;st=1.0,st(1)=adate,st(2)=k1,st(3)=nt1,st(4)=sdate
	fadd	st,st(2)				;st=k2=k1+1.0,st(1)=adate,st(2)=k1,st(3)=nt1,st(4)=sdate
;================================================================================

;################################################################################
;#			nt2=meanphase(adate,k2)					#
;################################################################################

	INVOKE	MeanPhase				;st=nt2=meanphase(adate,k2),st(1)=k2,st(2)=adate,st(3)=k1,st(4)=nt1,st(5)=sdate

;================================================================================

	fcom	st(5)					;st=nt2,st(1)=k2,st(2)=adate,st(3)=k1,st(4)=nt1,st(5)=sdate
	fstsw	ax					;retrieve exception flags from FPU
	fwait
	fxch	st(4)					;st=nt1,st(1)=k2,st(2)=adate,st(3)=k1,st(4)=nt2,st(5)=sdate
	sahf						;transfer to the CPU flags
	jna	MoonPhaseHunt00001

	fcom	st(5)					;st=nt1,st(1)=k2,st(2)=adate,st(3)=k1,st(4)=nt2,st(5)=sdate
	fstsw	ax					;retrieve exception flags from FPU
	fwait
	sahf						;transfer to the CPU flags
	jna	MoonPhaseHunt00002

MoonPhaseHunt00001:

	fstp	st					;st=k2,st(1)=adate,st(2)=k1,st(3)=nt2,st(4)=sdate
	fstp	st(2)					;st=adate,st(1)=k2,st(2)=nt2,st(3)=sdate
	jmp	MoonPhaseHunt00000

MoonPhaseHunt00002:					;st=nt1,st(1)=k2,st(2)=adate,st(3)=k1,st(4)=nt2,st(5)=sdate

	push	ebx

	lea	ebx,NewMoon
	lea	ecx,mcontent

	fsave	mcontent

MoonPhaseHunt00003:

	fldz						;st=0.0
	fld	REAL10 PTR[ecx+38]			;st=k2,st(1)=0.0

	INVOKE	TruePhase				;st=NextNewMoon

	fld	REAL10 PTR[ecx+78]			;st=sdate,st(1)=NextNewMoon
	fcomp	st(1)					;st=NextNewMoon
	fstsw	ax					;retrieve exception flags from FPU
	fwait
	sahf						;transfer to the CPU flags
	jc	MoonPhaseHunt00004

	fld	REAL10 PTR[ecx+38]			;st=k1=k2,st(1)=NextNewMoon
	fld	st					;st=k1,st(1)=k1,st(2)=NextNewMoon
	fstp	REAL10 PTR[ecx+58]			;st=k1,st(1)=NextNewMoon
	fld1						;st=1.0,st(1)=k1,st(2)=NextNewMoon
	fadd						;st=k2=k1+1.0,st(1)=NextNewMoon
	fstp	REAL10 PTR[ecx+38]			;st=NextNewMoon
	fstp	st
	jmp	MoonPhaseHunt00003

MoonPhaseHunt00004:

	fstp	REAL10 PTR[ebx+40]
	fldz						;st=0.0
	fld	REAL10 PTR[ecx+58]			;st=k1,st(1)=0.0

	INVOKE	TruePhase

	fld	st
	fstp	REAL10 PTR[ebx]				;st=NewMoon

;################################################################################
;#		Lunation=floor((NewMoon+7-lunatbase)/synmonth)+1		#
;################################################################################
	fadd	Seven					;st=NewMoon+7.0
	fsub	lunatbase				;st=NewMoon+7.0-lunatbase
	fdiv	synmonth				;st=(NewMoon+7.0-lunatbase)/synmonth

	INVOKE	FPUFloor				;st=floor((NewMoon+7.0-lunatbase)/synmonth)

	fistp	Lunation
;================================================================================

	fld	Quarter					;st=0.25
	fld	REAL10 PTR[ecx+58]			;st=k1,st(1)=0.25

	INVOKE	TruePhase				;st=FirstQuarter

	fstp	REAL10 PTR[ebx+10]

	fld	Half					;st=0.5
	fld	REAL10 PTR[ecx+58]			;st=k1,st(1)=0.5

	INVOKE	TruePhase				;st=FullMoon

	fstp	REAL10 PTR[ebx+20]

	fld	ThreeQuarters				;st=0.75
	fld	REAL10 PTR[ecx+58]			;st=k1,st(1)=0.75

	INVOKE	TruePhase				;st=LastQuarter

	fstp	REAL10 PTR[ebx+30]

	frstor	content

	pop	ebx

	ret

MoonPhaseHunt ENDP