.386
.model flat,stdcall
option casemap:none

include		\masm32\include\WINDOWS.inc
include		\masm32\include\kernel32.inc
include		\masm32\include\user32.inc
include		\masm32\include\gdi32.inc

includelib	\masm32\lib\kernel32.lib
includelib	\masm32\lib\user32.lib
includelib	\masm32\lib\gdi32.lib

WinMain		PROTO :DWORD,:DWORD,:DWORD,:DWORD

MoonPhaseCalculator	PROTO
SystemTimetoJulianDay	PROTO
JulianMoonPhase		PROTO
MoonPhaseHunt		PROTO
MeanPhase		PROTO
TruePhase		PROTO
JulianDaytoSystemTime	PROTO
JulianDaytoCalendar	PROTO
JulianDaytoDayofWeek	PROTO
JulianDaytoHourMinSec	PROTO
JulianDaytoASCII	PROTO
SystemTimetoASCII	PROTO :DWORD,:DWORD
MoonAgetoASCII		PROTO
MoonPhasetoASCII	PROTO
MoonDisttoASCII		PROTO
AngDiatoASCII		PROTO
SunDisttoASCII		PROTO
MoonPhaseInfoDisplay	PROTO :DWORD
FPUFloor		PROTO
FPUFix			PROTO
FPUFixAngle		PROTO
FPUDegtoRad		PROTO
FPUKepler		PROTO
FPUTan			PROTO
FPURadtoDeg		PROTO
FPURound		PROTO
FPUArcsin		PROTO
DrawMoon		PROTO :DWORD
Julian			PROTO :DWORD,:DWORD,:DWORD,:DWORD
UniversalTime		PROTO :DWORD,:DWORD,:DWORD,:DWORD
ASCIItoREAL		PROTO :DWORD
JulianTimetoASCII	PROTO
MoonPhaseBack		PROTO
MoonPhaseBitmap		PROTO
MoonPhaseBlack		PROTO :DWORD,:DWORD,:DWORD
MoonPhaseWhite		PROTO :DWORD,:DWORD,:DWORD

DWORDtoASCII		PROTO

.data

include		\LEMKE\Pics\FullMoon48.asm
;include		\LEMKE\Pics\FullMoon.asm
;include		\LEMKE\Pics\FullMoonbmp.asm
;include		\LEMKE\MoonPhaseX\FullMoonPhase.asm
include		\LEMKE\MoonPhaseX\MoonPhaseData.asm

ClassName	BYTE	"MoonClass",0
AppName		BYTE	"MoonPhase",0
MenuName	BYTE	"MoonMenu",0

StaticClass		BYTE	"STATIC",0

.data?

hInstance	HINSTANCE	?
CommandLine	DWORD		?

hwnd		HANDLE		?
hDLG		HANDLE		?
hIcon		HANDLE		?
hwndMoon	HANDLE		?
hbmpMoon	HANDLE		?
lpMoon32Bits	DWORD		?
lpMoon32MaskBits	DWORD		?

include		\LEMKE\MoonPhaseX\MoonPhaseDataQ.asm

.const

IDI_LOGO	equ		500

IDC_NOW		equ		3072
IDC_UTIME	equ		3073
IDC_JDAY	equ		3074
IDC_YEAR	equ		3075
IDC_MONTH	equ		3076
IDC_DAY		equ		3077
IDC_HOUR	equ		3078
IDC_MINUTE	equ		3079
IDC_SECOND	equ		3080
IDM_TESTMODE	equ		4096
IDM_STOP	equ		4097
IDM_RUN		equ		4098
IDM_SETJDAY	equ		4099
IDM_SETUTIME	equ		4100
IDM_EXIT	equ		4101
IDC_STATIC	equ		-1

.code

Start:

	INVOKE	GetModuleHandle,NULL								;kernel32.dll

	mov	hInstance,eax

	INVOKE	GetCommandLine									;kernel32.dll

	mov	CommandLine,eax

	INVOKE	WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT

	INVOKE	ExitProcess,eax									;kernel32.dll

include		\LEMKE\MoonPhaseX\WinMain.asm
include		\LEMKE\MoonPhaseX\WndProc.asm
include		\LEMKE\MoonPhaseX\MoonPhaseCalculator.asm
include		\LEMKE\MoonPhaseX\SystemTimetoJulianDay.asm
include		\LEMKE\MoonPhaseX\JulianMoonPhase.asm
include		\LEMKE\MoonPhaseX\MoonPhaseHunt.asm
include		\LEMKE\MoonPhaseX\MeanPhase.asm
include		\LEMKE\MoonPhaseX\TruePhase.asm
include		\LEMKE\MoonPhaseX\JulianDaytoSystemTime.asm
include		\LEMKE\MoonPhaseX\JulianDaytoCalendar.asm
include		\LEMKE\MoonPhaseX\JulianDaytoDayofWeek.asm
include		\LEMKE\MoonPhaseX\JulianDaytoHourMinSec.asm
include		\LEMKE\MoonPhaseX\JulianDaytoASCII.asm
include		\LEMKE\MoonPhaseX\SystemTimetoASCII.asm
include		\LEMKE\MoonPhaseX\MoonAgetoASCII.asm
include		\LEMKE\MoonPhaseX\MoonPhasetoASCII.asm
include		\LEMKE\MoonPhaseX\MoonDisttoASCII.asm
include		\LEMKE\MoonPhaseX\AngDiatoASCII.asm
include		\LEMKE\MoonPhaseX\SunDisttoASCII.asm
include		\LEMKE\MoonPhaseX\MoonPhaseInfoDisplay.asm
include		\LEMKE\MoonPhaseX\FPUFloor.asm
include		\LEMKE\MoonPhaseX\FPUFix.asm
include		\LEMKE\MoonPhaseX\FPUFixAngle.asm
include		\LEMKE\MoonPhaseX\FPUDegtoRad.asm
include		\LEMKE\MoonPhaseX\FPUKepler.asm
include		\LEMKE\MoonPhaseX\FPUTan.asm
include		\LEMKE\MoonPhaseX\FPURadtoDeg.asm
include		\LEMKE\MoonPhaseX\FPURound.asm
include		\LEMKE\MoonPhaseX\FPUArcsin.asm
include		\LEMKE\MoonPhaseX\DrawMoonZ.asm
include		\LEMKE\MoonPhaseX\UniversalTime.asm
include		\LEMKE\MoonPhaseX\JulianTimetoASCII.asm
include		\LEMKE\MoonPhaseX\MoonPhaseBlackZ.asm

END Start