MoonPhaseCalculator PROC
	LOCAL	content[108]:BYTE
	LOCAL	TextMetric:TEXTMETRIC

	INVOKE	GetTextMetrics,hdc,ADDR TextMetric		;gdi32.dll

	mov	ecx,10
	mov	eax,TextMetric.tmHeight
	add	eax,TextMetric.tmExternalLeading
	mov	LineSpace,eax
	mov	eax,TextMetric.tmMaxCharWidth
	mul	cl
	mov	InfoColumn,eax
	mov	edx,eax
	mov	eax,TextMetric.tmMaxCharWidth
	add	cl,6
	mul	cl
	add	eax,edx
	mov	LunationColumn,eax

	mov	eax,InfoColumn
	mov	MoonColumn,eax
	mov	MoonLunation,0

	xor	eax,eax
	xor	ecx,ecx
	lea	edx,szJulianDay

MoonPhaseCalculator00000:

	push	eax
	push	ecx
	push	edx
	push	ecx
	push	edx

	INVOKE	lstrlen,edx					;kernel32.dll

	pop	edx
	pop	ecx

	INVOKE	TextOut,hdc,3,ecx,edx,eax			;gdi32.dll

	pop	edx
	pop	ecx
	pop	eax
	
	add	edx,17
	add	ecx,LineSpace
	inc	eax
	cmp	al,3
	jb	MoonPhaseCalculator00000

	je	MoonPhaseCalculator00001

	cmp	al,7
	jb	MoonPhaseCalculator00000

	je	MoonPhaseCalculator00001

	cmp	al,9
	jb	MoonPhaseCalculator00000

	je	MoonPhaseCalculator00001

	cmp	al,14
	jb	MoonPhaseCalculator00000

	jmp	MoonPhaseCalculator00002

MoonPhaseCalculator00001:

	add	ecx,LineSpace
	jmp	MoonPhaseCalculator00000

MoonPhaseCalculator00002:
;TM0000:

	cmp	RunMode,TRUE
	je	MoonPhaseCalculator00003

	cmp	PaintIt,TRUE
	jne	MoonPhaseCalculator00005

	lea	edx,AJulianDay
	mov	eax,DWORD PTR[edx]
	mov	DWORD PTR[edx+10],eax
	mov	eax,DWORD PTR[edx+4]
	mov	DWORD PTR[edx+14],eax
	mov	eax,DWORD PTR[edx+6]
	mov	DWORD PTR[edx+16],eax

	jmp	MoonPhaseCalculator00006

MoonPhaseCalculator00003:

	INVOKE	GetTimeZoneInformation,ADDR TimeZoneInformation	;kernel32.dll

	mov	TIME_ZONE_ID,al

	INVOKE	WideCharToMultiByte,CP_ACP,NULL,ADDR TimeZoneInformation.StandardName,-1,ADDR szStandardName,32,NULL,NULL	;kernel32.dll

	INVOKE	WideCharToMultiByte,CP_ACP,NULL,ADDR TimeZoneInformation.DaylightName,-1,ADDR szDaylightName,32,NULL,NULL	;kernel32.dll

	INVOKE	GetLocalTime,ADDR LocalTime			;kernel32.dll

	INVOKE	GetSystemTime,ADDR SystemTime			;kernel32.dll

	lea	edx,FakeTime
	xor	ecx,ecx

MoonPhaseCalculator00004:

	mov	eax,DWORD PTR[edx+4*ecx+32]
	mov	DWORD PTR[edx+4*ecx],eax
	inc	ecx
	cmp	cl,4
	jne	MoonPhaseCalculator00004

	dec	(SYSTEMTIME PTR[edx]).wMonth

	lea	eax,JulianDay

	INVOKE	SystemTimetoJulianDay

MoonPhaseCalculator00005:

	cmp	PaintIt,TRUE
	je	MoonPhaseCalculator00006

	fsave	content

	fld	NextNewMoon
	fld	JulianDay
	fcom
	fstsw	ax
	fwait
	sahf

	frstor	content

	jna	MoonPhaseCalculator00007

MoonPhaseCalculator00006:

	mov	PaintIt,FALSE

	INVOKE	MoonPhaseHunt

MoonPhaseCalculator00007:

	INVOKE	JulianMoonPhase

	lea	edx,JulianDay

	INVOKE	JulianDaytoASCII

	INVOKE	MoonPhaseInfoDisplay,0

	lea	edx,JulianDay
	lea	eax,JulianTime

	INVOKE	JulianDaytoSystemTime

	INVOKE	SystemTimetoASCII,ADDR JulianTime,ADDR szUTC

	INVOKE	MoonPhaseInfoDisplay,1

	INVOKE	SystemTimeToTzSpecificLocalTime,ADDR TimeZoneInformation,ADDR JulianTime,ADDR LocalTime	;kernel32.dll

	cmp	TIME_ZONE_ID,TIME_ZONE_ID_DAYLIGHT
	lea	edx,szStandardName
	jne	MoonPhaseCalculator00008

	add	edx,32

MoonPhaseCalculator00008:

	INVOKE	SystemTimetoASCII,ADDR LocalTime,edx

	INVOKE	MoonPhaseInfoDisplay,2

	INVOKE	MoonAgetoASCII

	INVOKE	MoonPhaseInfoDisplay,4

	INVOKE	MoonPhasetoASCII

	INVOKE	MoonPhaseInfoDisplay,5

	INVOKE	MoonDisttoASCII

	INVOKE	MoonPhaseInfoDisplay,6

	lea	edx,MoonAngDia

	INVOKE	AngDiatoASCII

	INVOKE	MoonPhaseInfoDisplay,7

	INVOKE	SunDisttoASCII

	INVOKE	MoonPhaseInfoDisplay,9

	lea	edx,SunAngDia

	INVOKE	AngDiatoASCII

	INVOKE	MoonPhaseInfoDisplay,10

	lea	edx,NewMoon
	xor	eax,eax

MoonPhaseCalculator00009:

	push	edx
	push	eax
	push	eax

	mov	ecx,10
	mul	cl
	add	edx,eax
	lea	eax,JulianTime

	INVOKE	JulianDaytoSystemTime

	INVOKE	SystemTimetoASCII,ADDR JulianTime,ADDR szUTC

	pop	eax

	add	al,12

	INVOKE	MoonPhaseInfoDisplay,eax

	pop	eax
	inc	eax
	cmp	al,5

	pop	edx

	jne	MoonPhaseCalculator00009

	mov	eax,LunationColumn
	mov	MoonColumn,eax

	mov	eax,Lunation
	mov	Lunationx,eax
	xor	eax,eax

MoonPhaseCalculator00010:

	push	eax
	push	eax

	inc	MoonLunation
	inc	Lunationx

	push	Lunationx
	push	OFFSET FormatLunationtoASCII
	push	OFFSET StringBuffer

	call	wsprintf			;INVOKE	wsprintf,ADDR StringBuffer,ADDR FormatLunationtoASCII,Lunation	;user32.dll

	add	esp,12

	pop	eax

	add	al,12

	INVOKE	MoonPhaseInfoDisplay,eax

	pop	eax

	add	eax,4
	cmp	al,8
	jne	MoonPhaseCalculator00010

	push	ebx

	lea	ebx,FullMoon48
	mov	edx,lpMoon32Bits
	mov	ecx,576

MoonPhaseCalculator00011:

	dec	ecx
	mov	eax,DWORD PTR[ebx+4*ecx]
	mov	DWORD PTR[edx+4*ecx],eax
	jnz	MoonPhaseCalculator00011

	pop	ebx

	INVOKE	DrawMoon,BLACKNESS

	INVOKE	PostMessage,hwndMoon,STM_SETIMAGE,IMAGE_BITMAP,hbmpMoon	;user32.dll

	ret

MoonPhaseCalculator ENDP