WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL	ps:PAINTSTRUCT
	LOCAL	hdcMoon:DWORD

	cmp	uMsg,WM_TIMER
	jne	WndProc00000

	cmp	RunMode,TRUE
	jne	WndProc00005

	INVOKE	InvalidateRgn,hWnd,NULL,TRUE						;user32.dll

	xor	eax,eax
	ret

WndProc00000:

	cmp	uMsg,WM_PAINT
	jne	WndProc00001

	INVOKE	BeginPaint,hWnd,ADDR ps							;user32.dll

	mov	hdc,eax

	INVOKE	SetBkMode,hdc,TRANSPARENT						;gdi32.dll

	INVOKE	MoonPhaseCalculator

	INVOKE	EndPaint,hWnd,ADDR ps							;user32.dll

	xor	eax,eax
	ret

WndProc00001:

	cmp	uMsg,WM_COMMAND
	jne	WndProc00007

	mov	eax,wParam
	cmp	al,1

WndProc00002:

	je	WndProc00004

	cmp	al,3
	jnb	WndProc00003

	mov	PaintIt,TRUE

	mov	RunMode,TRUE

	INVOKE	SetTimer,hWnd,1,1000,NULL						;user32.dll

	INVOKE	GetMenu,hWnd								;user32.dll

	INVOKE	ModifyMenu,eax,IDM_RUN,MF_BYCOMMAND or MF_STRING,IDM_STOP,ADDR szStop	;user32.dll

	xor	eax,eax
	ret

WndProc00003:
;WPM0003:
	cmp	al,5
	jnb	WndProc00006

	INVOKE	DialogBoxParam,hInstance,ADDR szUTC,hWnd,ADDR UniversalTime,NULL	;user32.dll

	cmp	eax,FALSE
	je	WndProc00005
;WPM0001:
	mov	PaintIt,TRUE

	INVOKE	InvalidateRgn,hWnd,NULL,TRUE						;user32.dll

WndProc00004:

	mov	RunMode,FALSE

	INVOKE	KillTimer,hWnd,1							;user32.dll

	INVOKE	GetMenu,hWnd								;user32.dll

	INVOKE	ModifyMenu,eax,IDM_STOP,MF_BYCOMMAND or MF_STRING,IDM_RUN,ADDR szRun	;user32.dll

WndProc00005:

	xor	eax,eax
	ret

WndProc00006:

	jne	WndProc00086

	INVOKE	DestroyWindow,hWnd							;user32.dll

	xor	eax,eax
	ret

WndProc00007:

	cmp	uMsg,WM_CREATE
	jne	WndProc00008

	INVOKE	CreateWindowEx,NULL,ADDR StaticClass,ADDR AppName,\			;user32.dll
		WS_CHILD or WS_VISIBLE or SS_BITMAP or WS_CLIPSIBLINGS,524,24,48,48,\
		hWnd,NULL,hInstance,NULL

	mov	hwndMoon,eax

	INVOKE	GetDC,eax

	mov	hdcMoon,eax

	INVOKE	CreateDIBSection,hdcMoon,ADDR FullMoon48BMIH,DIB_RGB_COLORS,ADDR lpMoon32Bits,NULL,0	;gdi32.dll

	mov	hbmpMoon,eax

	INVOKE	ReleaseDC,hwndMoon,hdcMoon

	mov	RunMode,TRUE

	INVOKE	SetTimer,hWnd,1,1000,NULL						;user32.dll

	xor	eax,eax
	ret

WndProc00008:

	cmp	uMsg,WM_WINDOWPOSCHANGED
	jne	WndProc00009

	mov	edx,lParam
	mov	eax,DWORD PTR[edx+24]
	cmp	eax,33072
	jne	WndProc00086

	INVOKE	PostMessage,hWnd,WM_SYSCOMMAND,SC_RESTORE,NULL

	xor	eax,eax
	ret

WndProc00009:

	cmp	uMsg,WM_DESTROY
	jne	WndProc00086

	INVOKE	KillTimer,hWnd,1							;user32.dll

	INVOKE	PostQuitMessage,NULL							;user32.dll	FINISHED

	xor	eax,eax
	ret

WndProc00086:

	INVOKE	DefWindowProc,hWnd,uMsg,wParam,lParam					;user32.dll

	ret

WndProc ENDP